Rotate Image - Matrix - Leetcode 48

  Рет қаралды 244,518

NeetCode

NeetCode

Күн бұрын

Пікірлер: 297
@NeetCode
@NeetCode 2 жыл бұрын
🚀 neetcode.io/ - A better way to prepare for Coding Interviews
@meowmaple
@meowmaple 2 жыл бұрын
This is a clear explanation, but definitely still not the simplest. For me, the most straightforward method is to transpose the matrix and reverse each row. The code is simple and short. #transpose for row in range(len(matrix)): for col in range(row,len(matrix)): temp = matrix[row][col] matrix[row][col] = matrix[col][row] matrix[col][row] = temp #reverse for row in matrix: row.reverse() Accepted by leetcode.
@almasmirzakhmetov8590
@almasmirzakhmetov8590 2 жыл бұрын
excellent solution. By the way your solution is based on rotation matrix, right? For 90 degree, we have (x,y) -> (y,x) en.wikipedia.org/wiki/Rotation_matrix
@Rahul-pr1zr
@Rahul-pr1zr 2 жыл бұрын
How do you even get the idea to transpose and then reverse? I agree that implementation is easier but the idea doesn't seem that simple.
@333jjjjjj
@333jjjjjj 2 жыл бұрын
@@Rahul-pr1zr You need to recall it from your linear algebra class. Good luck if that was more than a few months ago or never.
@peterpace3379
@peterpace3379 2 жыл бұрын
@@333jjjjjj for me it was a whole year ago lmao
@przemysawpobrotyn1195
@przemysawpobrotyn1195 2 жыл бұрын
I have another solution in similar vein. I came up with it by eyeballing the leetcode provided input/output samples and noticing that the firs element of the last row of the input is the first element of the first row of the output, the second element of the last row of the input is the first element of the second row of the output etc. thus n = len(matrix) for row in matrix[::-1]: for i in range(n): element = row.pop(0) matrix[i].append(element) also does the job ;)
@srinadhp
@srinadhp 3 жыл бұрын
This has been one of the toughest problems for me. Very hard to visualize and always used to make mistakes even after multiple attempts. The way that you explained the approach is THE BEST. You made it so crystal clear in visualizing the solution. Thank you so much!
@sidkapoor9085
@sidkapoor9085 2 жыл бұрын
I found it way easier, almost trivial when I stopped looking at the "2D matrix" and just at the input and output lists.
@caniaccombo123
@caniaccombo123 2 жыл бұрын
@@sidkapoor9085 mind blown
@markomekjavic
@markomekjavic 2 жыл бұрын
I honestly think this is a Hard problem when it comes to implementation.. you can see the idea but coming up with the double pointer approach and a loop, thats a different story!
@huansir1922
@huansir1922 Жыл бұрын
@@markomekjavic yes,coming up with the double pointer approach , it seems hard
@princeanthony8525
@princeanthony8525 Жыл бұрын
Same here.
@doublegdog
@doublegdog 2 жыл бұрын
Just got an offer at amazon. Your videos rock and helped me out so much!
@NeetCode
@NeetCode 2 жыл бұрын
Congratulations 🎉
@JustinBieber38524
@JustinBieber38524 Ай бұрын
Hi hope you are doing good Can you please guide me how's your preparation looks like
@xqfang3171
@xqfang3171 3 жыл бұрын
This is the best explanation for this problem. Crystal clear visualization, elegant code. Great job. Thank you so much for posting!
@NeetCode
@NeetCode 3 жыл бұрын
Happy it was helpful! :)
@d1rtyharry378
@d1rtyharry378 3 жыл бұрын
Bro what an structured approach . Really loved your way of teaching man! You made it look so easy.
@NeetCode
@NeetCode 3 жыл бұрын
Thanks!
@parthpatel8532
@parthpatel8532 2 жыл бұрын
Although this is a good way to do it, I found my way to be a bit simpler once you understand matrix manipulation. Rotating a matrix by 90⁰ is equivalent to flipping the matrix diagonally and then flipping it vertically. First try it out with paper, and once u get it, it's really easy. It doesn't save runtime or anything, but I find it easier in terms of code than to move 4 things at a time layer by layer.
@jim5621
@jim5621 Жыл бұрын
Brilliant idea. But this solution takes 2x time since you need to loop through the matrix twice. But the time complexity is still O(n) though. Good thinking!
@brainmaxxing1
@brainmaxxing1 Жыл бұрын
​@@jim5621 "This solution takes 2x time" isn't actually true. Because of things like cache locality, where the elements that are in the same row will be closer to operate on for the CPU, it's not possible to say that the element-wise method is faster. The profiling method actually worked about 25% faster from tests on my computer!
@sanidhyax
@sanidhyax 4 ай бұрын
This is so elegant. Have solved multiple of 2d array problems but never thought of accessing the rows literally by [bottom[[R] and [top][L]
@MsSkip60
@MsSkip60 3 жыл бұрын
Thanks a lot for the content mate! No offence to others but I really like your clear accent and structured material which is easy to follow. Hope you keep up posting!
@lottexy
@lottexy 2 жыл бұрын
I gotta say your videos are amazing. I've been grinding LC for the past 3 weeks, I went from struggling to solve even 1 question on the weekly leetcode contest to solving 2 - 3 questions each week. Thank you so much. I've also and will always share your videos and excel sheet on reddit whenever people ask for leetcode tips. Oh and its abit late but congrats on the Google offer! I hope to one day get into google as well or any other company tbh ( my current tech job kinda blows ) ...
@suraj8092
@suraj8092 2 жыл бұрын
Good luck!
@mykytapiskarov7291
@mykytapiskarov7291 2 жыл бұрын
Amazing solution and explanaition! I spent about 2 hours trying to understand leetcode "Rotate group of 4" solution - but no luck. Here 15 minutes - and it's clear.
@vaibhavkhanna2922
@vaibhavkhanna2922 2 жыл бұрын
Great approach! Here you can see if you are confused with variable naming I have used some easy to understand names.Approach is still the same. void rotate(vector &matrix) { int size = matrix.size(); int startRow = 0; int startColumn = 0; int endRow = matrix.size() - 1; int endColumn = matrix.size() - 1; while (startRow < endRow && startColumn < endColumn) { int current_column_for_start_row = startColumn; int current_row_for_end_Column = startRow; int current_column_for_end_row = endColumn; int current_row_for_start_column = endRow; int current_size = endColumn - startColumn; for (int i = 0; i < current_size; i++) { int temp = matrix[startRow][current_column_for_start_row]; matrix[startRow][current_column_for_start_row] = matrix[current_row_for_start_column][startColumn]; matrix[current_row_for_start_column][startColumn] = matrix[endRow][current_column_for_end_row]; matrix[endRow][current_column_for_end_row] = matrix[current_row_for_end_Column][endColumn]; matrix[current_row_for_end_Column][endColumn] = temp; current_column_for_start_row++; current_row_for_end_Column++; current_column_for_end_row--; current_row_for_start_column--; } startRow++; startColumn++; endRow--; endColumn--; } }
@suhasdon1
@suhasdon1 3 жыл бұрын
Thank you. Best explanation without having to deal with 2 for loops with i, j or recursion and all other BS to be worried about.
@emanawel9224
@emanawel9224 2 жыл бұрын
This code makes the problem look way easier than it is! Love the code and explanation.
@ArunRampure
@ArunRampure 4 ай бұрын
Have been struggling with coming up with an notion of using boundaries and using that i variable. Neet explanations for the neet code to write. Thanks for adding this.
@mhdzahir423
@mhdzahir423 Ай бұрын
Broo! your explanation is fantastic! as a beginner, this whole and sole problem made me understand how to play with 2D matrix in any situation!
@yabgdouglas6032
@yabgdouglas6032 Жыл бұрын
my ego has made me attempt this problem almost 3 hours - thank you for this clean explanation!
@wij8044
@wij8044 Жыл бұрын
Easier solution for nXn matrix! Neetcode solution may be better suited for nXm matrix. function rotate(matrix: number[][]): void { const n = matrix.length; // Transpose the matrix, starting from i = 1 for (let i = 1; i < n; i++) { for (let j = i; j < n; j++) { [matrix[i][j], matrix[j][i]] = [matrix[j][i], matrix[i][j]]; } } // Reverse each row for (let i = 0; i < n; i++) { matrix[i].reverse(); } }
@himanshubansal7040
@himanshubansal7040 2 жыл бұрын
This is a beautiful way to write the code for this tricky problem. Kudos!!
@DanielTruongDev
@DanielTruongDev 2 жыл бұрын
Great explanation, however if you recalled from Linear Algebra, this is basically transpose the matrix so (row,col) becomes (col,row). So here's a shorter solution in Python rows = len(matrix) matrix.reverse() #Reverse the matrix for r in range(rows): for c in range(r,rows): matrix[r][c], matrix[c][r] = matrix[c][r], matrix[r][c] #Transpose
@nayanachandran7072
@nayanachandran7072 2 жыл бұрын
I must've have tried to understand this problem atleast 10 times and always failing to remember it. I now know I will never forget it! Thanks!
@codewithtejesh1284
@codewithtejesh1284 3 жыл бұрын
thanks a lot, great explanation! i stopped my leetcode subscription , now i am just watching your videos and solving question.
@ishaanjain4973
@ishaanjain4973 Жыл бұрын
I cant explain you how much this channel helps me !! Other channels just tell the transpose method which is not so intuitive, you always tell solutions which I can think in future in real interviews and exams. Thanks a lot Neetcode !! Keep up the good work man
@sureshgarine
@sureshgarine 3 жыл бұрын
I really like the way u handled minimizing the temp variable swap. very well explained. Thank you so much.
@huimingli9207
@huimingli9207 Жыл бұрын
This is really a pure math problem. rotating a cell 90 degree, the index/coordinate change is from (x,y) -> (y, n-1-x).
@jananiadanurrammohan9795
@jananiadanurrammohan9795 2 жыл бұрын
Best explanation one could ever give for a problem!!!. Thank you for the effort and time you are putting into making all these videos.
@krishnateja6428
@krishnateja6428 Жыл бұрын
Cleanest explanation I have ever seen. Thank you!
@josecarlosfontanesikling306
@josecarlosfontanesikling306 Жыл бұрын
It's possible to do this without any extra memory at all. Suppose you have variables x and y. You can swap them like this y=y+x x=y-x y=y-x This is all you need to transpose a matrix and to swap columns or rows. This rotation is just a transposition followed by inverting the order of the rows.
@annieonee
@annieonee 2 жыл бұрын
This is the best explanation of this problem so I've found. Thank you so much for the content! Keep up the good work 👏
@anxonpues6018
@anxonpues6018 5 ай бұрын
Good, explanation, improoving steps ... really golden pedagogical
@AlfredPros
@AlfredPros 2 ай бұрын
While the LeetCode problem doesn't want the cheat solution, I tried it anyway and do the following code. def rotate(self, matrix: List[List[int]]) -> None: mat = list(zip(*matrix[::-1])) for j in range(len(matrix)): for i in range(len(matrix[0])): matrix[j][i] = mat[j][i] This code performs almost as fast as the solution with a caveat that it uses more memory.
@dineshraj5957
@dineshraj5957 Жыл бұрын
The best explanation by far of the layer rotation method. Damn it. The best!!
@dr.merlot1532
@dr.merlot1532 2 жыл бұрын
The guys talking about transpose mean this: Geometrically, rotation of the plane by 90 degrees is equivalent to flipping about the diagonal line y=-x and then flipping about the y-axis. That's why this works.
@Cruzylife
@Cruzylife 2 жыл бұрын
wow this explanation was so clear and the code was so clean!!
@bruce716
@bruce716 2 жыл бұрын
Thanks for the details and it is really easier to understand the concept with your good variable naming convention.
@kwaminaessuahmensah8920
@kwaminaessuahmensah8920 2 жыл бұрын
Mans went into god mode swapping the elements in reverse
@yasharma2301
@yasharma2301 2 жыл бұрын
Knew the O(2*n^2) solution using transpose followed by inversion, thanks for this great one pass solution.
@zekonja90
@zekonja90 2 жыл бұрын
C# solution: public void Rotate(int[][] matrix) { int n = matrix.Length; for (int i = 0; i < n; i++) { for (int j = i; j < n; j++) { int tmp = matrix[i][j]; matrix[i][j] = matrix[j][i]; matrix[j][i] = tmp; } Array.Reverse(matrix[i]); } } Cheers!
@sumosam1980
@sumosam1980 3 жыл бұрын
Your videos are excellent. You do a great job of being super clear! I often come here to Neetcode to see if you have the solution as it is better than the official explanation. Keep up the great work!
@calvin_713
@calvin_713 5 күн бұрын
Super duper helpful! This math question is tricky as hell...
@bilalahmedkhan9518
@bilalahmedkhan9518 2 жыл бұрын
I thought this was a very though problem but you made it so easy for me. Thank you!
@dollyvishwakarma2
@dollyvishwakarma2 2 жыл бұрын
No doubt I love your simple algos but this one can be done in a much simpler way which is to reverse the matrix row wise and then swapping the elements like we do for a transpose. Kudos to the great work you do :)
@user-xg2wj4dy5f
@user-xg2wj4dy5f Жыл бұрын
But to do that you will have to create another matrix which is the copy of the Matrix which is to be transposed and that is against the constraints of the question you have to work in the same Matrix
@welcomb
@welcomb 2 жыл бұрын
There a very easy way to do this. First transpose the matrix, which is just flipping along a diagonal in-place. Then reflect vertically, which is another simple in-place swap.
@Qxismylife
@Qxismylife 2 жыл бұрын
I am thinking about the same. But the problem is we don't know if this is allowed, at least for the purpose of what this question is examining. If this is allowed then you can also use the 2D rotation matrix too.
@Qxismylife
@Qxismylife 2 жыл бұрын
Just saw other comments. This is allowed. I am happy now.
@welcomb
@welcomb 2 жыл бұрын
@@Qxismylife using a 2D rotation matrix may not be inplace as you need extra space for the matrix. Transpose and flip can both be done inplace
@nayandhabarde
@nayandhabarde 3 жыл бұрын
Good work with comments and simplicity!
@burburchacha
@burburchacha 11 ай бұрын
I hope you realise that you have a gift in explaining difficult concepts
@seungjunlee00
@seungjunlee00 2 жыл бұрын
Thank you so much for the straightforward and clear answer!
@ElijahGeorge
@ElijahGeorge 2 жыл бұрын
This is a very intuitive explanation. Thanks so much!!
@jimmycheong7970
@jimmycheong7970 2 жыл бұрын
This is a freaking amazing explanation. Thank you so much for sharing!
@Ilmard99
@Ilmard99 2 жыл бұрын
1) Invert the order of the rows 2) Transpose
@KarthikChintalaOfficial
@KarthikChintalaOfficial 5 ай бұрын
Like the approach. But it's tedious to really remember and do it. I like the transposing and reversing using a 2 ptr approach to do this.
@IncrementalNova
@IncrementalNova 3 жыл бұрын
Great content Bro :) Solution in Java: class Solution { public void rotate(int[][] matrix) { int n = matrix.length; int right=n-1, left=0; //neetcode solution video while(left
@sebastian_tec
@sebastian_tec 2 жыл бұрын
@theraplounge because as you enter in the inner loops the offset, or the amout that you have to add/subtract for the rotation decreases. in the video for the outer matrix the offset can be as much as 2, but in the inner matrix that offset is 0.
@inspiredomkar1239
@inspiredomkar1239 Жыл бұрын
Thanks. I was looking for it.
@pampanasubrahmanyam5693
@pampanasubrahmanyam5693 2 жыл бұрын
small correction, in the for loop, at the range function it should be range(r) not range(r-1) for python3
@rohatgiy
@rohatgiy 2 жыл бұрын
bro it’s an L
@nikiforovsansanich
@nikiforovsansanich 2 жыл бұрын
Perfect explanation! Thank you!
@leonfeng4006
@leonfeng4006 2 жыл бұрын
please continue to make more videos, this channel is pure gold
@alinisar87
@alinisar87 3 жыл бұрын
Beautiful solution, great explanation. Thank you so much.
@mr.anonymous6098
@mr.anonymous6098 2 жыл бұрын
Perfect Solution. When I first read the solution in the Cracking the coding interview book, I spent quite a lot of time and still could not understand it. You really simplified the logic which is so much easier to follow! Great Job, man
@sanketkoli8641
@sanketkoli8641 Жыл бұрын
Very nice explanation. Thanks NeetCode!
@chichiem2397
@chichiem2397 2 жыл бұрын
These videos are great, this one in particular is perfect. I struggled with this a lot until I checked out this video. Awesome stuff!
@Michael-zh3op
@Michael-zh3op 4 ай бұрын
After playing around with matrices, this question was a cake walk.
@shivaacharya7247
@shivaacharya7247 2 жыл бұрын
Great explanation! For some weird reason, for loop with range(l, r) does not pass all test cases!
@markvaldez526
@markvaldez526 2 жыл бұрын
My code isn't passing either...
@shivaacharya7247
@shivaacharya7247 2 жыл бұрын
@@markvaldez526 range(l, r) doesn't work because we are iterating r - l times, not from l to r. For example, if l = 5, and r = 10, we need to run our for loop 5 times starting index from 0, 1, 2, 3, and 4 NOT from 5, 6, 7, 8, 9 which would be the case if we do range(5, 10).
@ugochukwustephenmbonu7974
@ugochukwustephenmbonu7974 2 жыл бұрын
@@shivaacharya7247 thanks for explaining. Cleared it up for me!
@siddharthgupta6162
@siddharthgupta6162 2 жыл бұрын
This video is so so so (X100) much better than the leetcode's solutions on this problem.
@pengmick2046
@pengmick2046 Жыл бұрын
Your explanation is so good
@itspete2444
@itspete2444 8 ай бұрын
"This is still a square if you tilt your head enough" - that got me laughing harder than it should have
@eltaylor778
@eltaylor778 Жыл бұрын
Great explanation, does anyone know why the range has to be range(right- left) instead of range(left,right)? The range(left,right) works on many of the smaller test cases but does not work on many of the harder ones. Help!
@kritmok1875
@kritmok1875 Жыл бұрын
that's because we always want to start the i with 0. let's take (2, 4) as an example range(2,4) return 2,3 but range(4-2) return 0, 1
@ShivangiSingh-wc3gk
@ShivangiSingh-wc3gk 2 жыл бұрын
Nice, explanation. I thought the same thing but got thrown off on how to get the indexes
@voxel9470
@voxel9470 2 ай бұрын
Apparently you can rotate by transposing the matrix and then flipping each row. I've seen that solution be better than the way you illustrated here I'm assuming because it's more cache friendly in the flip phase.
@Kenny-st8cg
@Kenny-st8cg Жыл бұрын
Since its python you can just do def rotate(self, matrix: List[List[int]]) -> None: n = len(matrix) l, r = 0, n - 1 while l < r: top, bottom = l, r for i in range(r - l): ( matrix[top + i][r], matrix[top][l + i], matrix[bottom - i][l], matrix[bottom][r - i] ) = ( matrix[top][l + i], matrix[bottom - i][l], matrix[bottom][r - i], matrix[top + i][r] ) r -= 1 l += 1 So theres no need for a temp variable, in that case we also wouldnt have to care about doing it in reverse. But I think readablitiy suffers a little
@brainmaxxing1
@brainmaxxing1 Жыл бұрын
An even better solution to consider: n = len(matrix) # Transpose Matrix for i in range(n): for j in range(i, n): matrix[i][j], matrix[j][i] = matrix[j][i], matrix[i][j] # Reverse Matrix for row in matrix: row.reverse()
@Kenny-st8cg
@Kenny-st8cg Жыл бұрын
@@brainmaxxing1 Sure, but the TC of that solution is obviously much worse. For that solution theres no need for the second for loop either: n = len(matrix) for row in range(n): for col in range(row + 1, n): matrix[col][row], matrix[row][col] = matrix[row][col], matrix[col][row] matrix[row].reverse()
@brainmaxxing1
@brainmaxxing1 Жыл бұрын
The time complexity of both solutions is the same, O(n^2). You do more 'operations' but the performance is actually better in my testing (somehow because of how the computer handles the more common operations of reversing a row and transposing a matrix) My notebook testing all 3 colab.research.google.com/drive/1laaMa1XLalAsShcoqENbbD5peb-PdCHo#scrollTo=QSThsieXZiCO Also nice on removing the second loop, that does speed it up.
@ChocolateMilkCultLeader
@ChocolateMilkCultLeader 2 жыл бұрын
Your code was really elegant. Well done
@UmaAbhinavHindu
@UmaAbhinavHindu 18 күн бұрын
Great solution. Thanks
@navenkumarduraisamy6260
@navenkumarduraisamy6260 3 жыл бұрын
I really wish I had such clear approach
@ashinshenoy84
@ashinshenoy84 2 жыл бұрын
Very well explained, but i spotted one line which could be shifted up. Line 10 can be put before the for loop isnt it ? no need to initialize it on every loop
@KaushikChavali
@KaushikChavali Жыл бұрын
I like the intuitively named variables.
@akshaibaruah1720
@akshaibaruah1720 2 жыл бұрын
literally my go to channel..well was it really asked by microsoft?...I solved it by taking its transpose and then reversing it which is in place but needs two traversal
@Tensor08
@Tensor08 3 жыл бұрын
I did this in one line 😎 which beats 97% matrix[:] = list(zip(*matrix[::-1]))
@reaiswaryaa
@reaiswaryaa 2 жыл бұрын
Wow what an amazing explanation. Thank you !
@TheMzbac
@TheMzbac 2 жыл бұрын
Very clearly explained, thank you
@SarveshBhatnagar1214
@SarveshBhatnagar1214 2 жыл бұрын
I found more two approaches to this, First one is to reverse the image and then transpose the resulting matrix (Easier). Other approach is to do this matrix[:] = zip(*matrix[::-1]) I don't really understand what's happening here so if someone understands, please do tell :) Thanks!
@anandsrikumar007
@anandsrikumar007 4 ай бұрын
I took a temp array, copied all columns into the rows of the temp array but in reverse order, finally, I iterated the temp array and replaced matrix[row] = temp_array[row]
@johnlocke4695
@johnlocke4695 2 жыл бұрын
There is no way I could have figured this out myself. Not even if they give me a million years time.
@Bingo901
@Bingo901 2 жыл бұрын
You can transpose the matrix in place and reverse each row to achieve the same result
@akifozkan5065
@akifozkan5065 3 жыл бұрын
made it look like so simple, great explanation
@peterosi192
@peterosi192 2 жыл бұрын
Now this... I like!
@maxwong4657
@maxwong4657 8 ай бұрын
I use JS. The same code but doesnt work! can't pass the case 6. I checked many times and asked GPT, GPT gave the correct answer, but leetcode didnt. Can anyone pass the case 6 with JS? var rotate = function (matrix) { let left = 0 let right = matrix.length - 1 while (left < right) { for (let i = left; i < right; i++) { let top = left let bottom = right const topLeft = matrix[top][left + i] matrix[top][left + i] = matrix[bottom - i][left] matrix[bottom - i][left] = matrix[bottom][right - i] matrix[bottom][right - i] = matrix[top + i][right] matrix[top + i][right] = topLeft } left++ right-- } };
@AshishSarin1
@AshishSarin1 2 жыл бұрын
Thanks for this explanation. Really liked it.
@NeetCode
@NeetCode 2 жыл бұрын
Thank you so much!! Glad it was helpful!
@harishsn4866
@harishsn4866 2 жыл бұрын
Thank you so much. You're the best.
@alexeymelezhik6473
@alexeymelezhik6473 Жыл бұрын
"top" and "bottom" variables are not necessary, one could replace them by "l" and "r"
@brainmaxxing1
@brainmaxxing1 Жыл бұрын
Sure, but why sacrifice readability? The difference is very small in terms of memory usage
@rohitkumaram
@rohitkumaram 2 жыл бұрын
still your logic a more pythonic approach: class Solution: def rotate(self, matrix: List[List[int]]) -> None: l = 0 r = len(matrix) -1 while l
@stith_pragya
@stith_pragya 2 жыл бұрын
Thank You Brother for this amazing video.............🙏🙏🙏🙏🙏🙏
@zekaiimran2464
@zekaiimran2464 3 ай бұрын
Best solution! thanks.
@hunglam2680
@hunglam2680 3 жыл бұрын
thank you. this problem has been bugging me, i figured out how to rotate the image but couldn't implement it properly.
@franly656
@franly656 Жыл бұрын
hi neetcode, i have a question, how to rotate matrix 45 degrees so the matrix size will increase, i trying to make the solution and now i want to give up (i have tried straight 5 hours btw). Can you make this solution a video pls.
@preetirani8272
@preetirani8272 Жыл бұрын
List2 = [] for x in range(len(matrix[0])): List1=[] for y in matrix[::-1]: list1.append(y[×]) List2.append(list1) return list2 Why this code is giving wrong output in leetcode but right output in local jupyter notebook
@nilkamalthakuria4030
@nilkamalthakuria4030 3 жыл бұрын
Great explanation
@eltonlobo8697
@eltonlobo8697 3 жыл бұрын
There's another approach to this problem: -Swap the non-diagonal elements (Because we want to make rows columns and vice-versa) -Use two pointers, one at the first column and the other at the last column, swap column elements -Do the above step until the first pointer is no more lesser than the second pointer (Last 2 steps are just to swap columns) Code: class Solution: def rotate(self, matrix: List[List[int]]) -> None: """ Do not return anything, modify matrix in-place instead. """ n=len(matrix) r=0 while (r
@plotfi1
@plotfi1 Жыл бұрын
I find the standard rotation technique to be pretty frustrating to think about. Instead ive found its easier to invert the values on the diagonal then reverse the rows.
@samuelrobert2927
@samuelrobert2927 2 сағат бұрын
Transpose and reverse in each row
@khatharrmalkavian3306
@khatharrmalkavian3306 2 жыл бұрын
You know you can just swap instead of using a temporary. Walk through it: Swap TL with TR Swap TL with BR Swap TL with BL Shazam, the corners are rotated and aux space is O(0).
@trongthuong9581
@trongthuong9581 2 жыл бұрын
How can u perform swap without temp variable xD
@khatharrmalkavian3306
@khatharrmalkavian3306 2 жыл бұрын
@@trongthuong9581 There are two common methods and one other method that is CPU dependent: A) XOR swap: x ^= y y ^= x x ^= y B) Mathematical swap: x += y y = x - y x -= y C) x86 and x64 CPUs have the XCHG instruction, but it's likely to have the same performance as the other methods. Theoretically it would be faster since it can target a memory value directly, but doing so causes the CPU to lock all cores for synchronization, which is a massive performance hit. Operating just on registers, it has about 3 cycles of latency, which is similar to the XOR and mathematical methods.
@karthikjayaraman9646
@karthikjayaraman9646 3 жыл бұрын
Excellent article. Keep'em coming!
@deewademai
@deewademai 2 жыл бұрын
10:28 confuses me. range (L, r -1) does not the same as range (r -L)
@jagrutitiwari2551
@jagrutitiwari2551 Жыл бұрын
The explanation was amazing. I find subtracting i a little confusing. Though dry run help me understand how it works. How do I remember it when I code?
@Yougottacryforthis
@Yougottacryforthis 11 ай бұрын
pen and paper
Rotate Matrix/Image by 90 Degrees | Brute - Optimal
17:47
take U forward
Рет қаралды 248 М.
Making an Algorithm Faster
30:08
NeetCodeIO
Рет қаралды 147 М.
When u fight over the armrest
00:41
Adam W
Рет қаралды 31 МЛН
Long Nails 💅🏻 #shorts
00:50
Mr DegrEE
Рет қаралды 13 МЛН
Jump Game - Greedy - Leetcode 55
16:28
NeetCode
Рет қаралды 255 М.
LRU Cache - Twitch Interview Question - Leetcode 146
17:49
NeetCode
Рет қаралды 300 М.
LeetCode was HARD until I Learned these 15 Patterns
13:00
Ashish Pratap Singh
Рет қаралды 577 М.
Watching Neural Networks Learn
25:28
Emergent Garden
Рет қаралды 1,3 МЛН
Dijkstra's Algorithm - Computerphile
10:43
Computerphile
Рет қаралды 1,3 МЛН
Dynamic Programming isn't too hard. You just don't know what it is.
22:31
DecodingIntuition
Рет қаралды 197 М.
All Rust string types explained
22:13
Let's Get Rusty
Рет қаралды 183 М.
Implement Trie (Prefix Tree) - Leetcode 208
18:56
NeetCode
Рет қаралды 212 М.
How I would learn Leetcode if I could start over
18:03
NeetCodeIO
Рет қаралды 687 М.
The Art of Code - Dylan Beattie
1:00:49
NDC Conferences
Рет қаралды 4,7 МЛН
When u fight over the armrest
00:41
Adam W
Рет қаралды 31 МЛН